//
//  AddBookIntent.swift
//  BooksShelfCustomIntent
//
//  Created by Giugliano Antonella on 18/04/25.
//

import AppIntents

struct AddBookIntent: AppIntent {
    static var title: LocalizedStringResource = "Add a Book to your Shelf"
    
    @Parameter(title: "Title")
    var title: String
    
    @Parameter(title: "Author")
    var author: String
    
    @Parameter(title: "Genre")
    var genre: Genre
    
    @Parameter(title: "Type of book")
    var type: BookContentType?
    
    @Dependency
    private var navigationManager: NavigationManager
    
    @MainActor
    func perform() async throws -> some IntentResult {
        
        let newBook = Book(title: title, author: author, genre: genre, contentType: type)
        
        do{
            
            try await DataManager.createNewBook(book: newBook)
        }catch{
            fatalError("Unable to save the book")
        }
        
        navigationManager.openBook(book: newBook)
        return .result()
    }
}
